ghc-9.6.3: The GHC API

Safe Haskell | Safe-Inferred
Language | Haskell2010

GHC.Core.Opt.SetLevels

# Documentation

setLevels :: FloatOutSwitches -> CoreProgram -> UniqSupply -> [LevelledBind] Source #

data Level Source #

Constructors

Level Int Int LevelType |

#### Instances

Instances details

Outputable Level Source # |
Instance details Defined in GHC.Core.Opt.SetLevels Methods ppr :: Level -> SDoc Source #
Eq Level Source # |
Instance details Defined in GHC.Core.Opt.SetLevels Methods (==) :: Level -> Level -> Bool # (/=) :: Level -> Level -> Bool #

data LevelType Source #

Constructors

BndrLvl |
JoinCeilLvl |

#### Instances

Instances details

Eq LevelType Source # |
Instance details Defined in GHC.Core.Opt.SetLevels Methods (==) :: LevelType -> LevelType -> Bool # (/=) :: LevelType -> LevelType -> Bool #

tOP_LEVEL :: Level Source #

isJoinCeilLvl :: Level -> Bool Source #

asJoinCeilLvl :: Level -> Level Source #

type LevelledBind = TaggedBind FloatSpec Source #

type LevelledExpr = TaggedExpr FloatSpec Source #

type LevelledBndr = TaggedBndr FloatSpec Source #

data FloatSpec Source #

Constructors

FloatMe Level |
StayPut Level |

#### Instances

Instances details

Outputable FloatSpec Source # |
Instance details Defined in GHC.Core.Opt.SetLevels Methods ppr :: FloatSpec -> SDoc Source #

floatSpecLevel :: FloatSpec -> Level Source #

incMinorLvl :: Level -> Level Source #

ltMajLvl :: Level -> Level -> Bool Source #

ltLvl :: Level -> Level -> Bool Source #

isTopLvl :: Level -> Bool Source #